package activeobject;

import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

import java.math.BigInteger;

// ActiveObject󥿥եμ饹
class ActiveObjectImpl implements ActiveObject {
    private final ExecutorService service = Executors.newSingleThreadExecutor();

    // ӥνλ
    public void shutdown() {
        service.shutdown();
    }

    // ͤΤƤӽФ
    public Future<String> makeString(final int count, final char fillchar) {
        // ꥯ
        class MakeStringRequest implements Callable<String> {
            public String call() {
                char[] buffer = new char[count];
                for (int i = 0; i < count; i++) {
                    buffer[i] = fillchar;
                    try {
                        Thread.sleep(100);
                    } catch (InterruptedException e) {
                    }
                }
                return new String(buffer);
            }
        }
        // ꥯȤȯ
        return service.submit(new MakeStringRequest());
    }

    // ͤΤʤƤӽФ
    public void displayString(final String string) {
        // ꥯ
        class DisplayStringRequest implements Runnable {
            public void run() {
                try {
                    System.out.println("displayString: " + string);
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                }
            }
        }
        // ꥯȤȯ
        service.execute(new DisplayStringRequest());
    }

    // ͤΤƤӽФ
    public Future<String> add(final String x, final String y) {
        // ꥯ
        class AddRequest implements Callable<String> {
            public String call() throws NumberFormatException {
                BigInteger bigX = new BigInteger(x);
                BigInteger bigY = new BigInteger(y);
                BigInteger bigZ = bigX.add(bigY);
                return bigZ.toString();
            }
        }
        // ꥯȤȯ
        return service.submit(new AddRequest());
    }
}
