public final class ReadWriteLock {
    private int readingReaders = 0; // (A) ºݤɤǤΥåɤο
    private int waitingWriters = 0; // (B) 񤯤ΤԤäƤ륹åɤο
    private int writingWriters = 0; // (C) ºݤ˽񤤤ƤΥåɤο
    private boolean preferWriter = true; // 񤯤Τͥ褹ʤtrue

    public synchronized void readLock() throws InterruptedException {
        while (writingWriters > 0 || (preferWriter && waitingWriters > 0)) {
            wait();
        }
        readingReaders++;                       // (A) ºݤɤǤ륹åɤο1䤹
    }

    public synchronized void readUnlock() {
        readingReaders--;                       // (A) ºݤɤǤ륹åɤο1餹
        preferWriter = true;
        notifyAll();
    }

    public synchronized void writeLock() throws InterruptedException {
        waitingWriters++;                       // (B) 񤯤ΤԤäƤ륹åɤο1䤹
        try {
            while (readingReaders > 0 || writingWriters > 0) {
                wait();
            }
        } finally {
            waitingWriters--;                   // (B) 񤯤ΤԤäƤ륹åɤο1餹
        }
        writingWriters++;                       // (C) ºݤ˽񤤤Ƥ륹åɤο1䤹
    }

    public synchronized void writeUnlock() {
        writingWriters--;                       // (C) ºݤ˽񤤤Ƥ륹åɤο1餹
        preferWriter = false;
        notifyAll();
    }
}
